using System;
using System.Drawing;
using System.Text;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Keyoti.SearchEngine.DataAccess;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.Search;
using Keyoti.SearchEngine.Index;

namespace NewWordParser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox1;
        private Button testSearchBT;
        private TextBox textBox2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.testSearchBT = new System.Windows.Forms.Button();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(16, 8);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 0;
            this.button1.Text = "Build Index";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(16, 48);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(568, 32);
            this.textBox1.TabIndex = 1;
            this.textBox1.Text = "Click Build Index And Wait Please";
            // 
            // testSearchBT
            // 
            this.testSearchBT.Location = new System.Drawing.Point(508, 8);
            this.testSearchBT.Name = "testSearchBT";
            this.testSearchBT.Size = new System.Drawing.Size(75, 23);
            this.testSearchBT.TabIndex = 2;
            this.testSearchBT.Text = "Test Search";
            this.testSearchBT.Click += new System.EventHandler(this.testSearchBT_Click);
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(348, 10);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(154, 20);
            this.textBox2.TabIndex = 3;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(600, 91);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.testSearchBT);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.button1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{	
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.action();
		}


		private void action()
		{


			Keyoti.SearchEngine.Configuration config = new Keyoti.SearchEngine.Configuration();
            config.IndexDirectory = Application.StartupPath+"\\..\\..\\IndexDirectory";

            config.CentralEventDispatcher.NeedObject += new Keyoti.SearchEngine.Events.NeedObjectEventHandler(CentralEventDispatcher_NeedObject);

			//Use our customized DocumentIndex subclass.
			DocumentIndex docIdx = new DocumentIndex(config);

			//For this project we DO want to reindex files regardless of when they were modifed
			config.IgnoreLastModifiedDate = true;

			//Use as normal, add docs if necessary and build.
            try
            {
                docIdx.AddDocument(new Document("http://localhost/userguide.pdf", config));
            }
            finally
            {
                docIdx.Close();
            }

			MessageBox.Show("Finished.");

		}

        void CentralEventDispatcher_NeedObject(object sender, Keyoti.SearchEngine.Events.NeedObjectEventArgs e)
        {
            if (e.RequiredObject is ParserProvider)
                e.RequiredObject = new CustomParserProvider(Application.StartupPath + "\\..\\..\\TempDir\\temp.pdf", e.Configuration);
        }

        

        private void testSearchBT_Click(object sender, EventArgs e)
        {
            Keyoti.SearchEngine.Configuration config = new Keyoti.SearchEngine.Configuration();
            config.IndexDirectory = Application.StartupPath + "\\..\\..\\IndexDirectory";

            string key = "5651665D6359655E675869686059653752403E3B373D413A473C42414343414C4F4D4A9";//put your own key here
            SearchAgent sa = new SearchAgent(key, config);
            MessageBox.Show(this, sa.Search(textBox2.Text, 1, 10).Count + " result(s) found.");

        }


	}
}
